package com.six_group.sse.seni.guicontrols.checkboxcombo;

import javafx.beans.value.ObservableValue;
import javafx.scene.control.cell.CheckBoxListCell;
import javafx.util.Callback;

/**
 * Cell for {@link CheckBoxComboBox}.
 * 
 * @author tkcr1
 *
 * @param <T>
 *            {@link CheckBoxComboBox#T}
 */
public class CustomCheckBoxListCell<T> extends CheckBoxListCell<T> {

	private CheckBoxComboBox<T>	_parent;

	public CustomCheckBoxListCell(CheckBoxComboBox<T> parent, Callback<T, ObservableValue<Boolean>> callback) {
		super(callback);
		_parent = parent;
	}

	@Override
	public void updateItem(T item, boolean empty) {
		super.updateItem(item, empty);

		if (_parent != null) {
			ICheckBoxComboBoxCellRenderer<T> renderer = _parent.getCellRenderer();

			if (!empty && renderer != null) {
				setText(_parent.getCellRenderer().getDisplayText(item));
				if (renderer.getDisplayImage(item) != null) {
					setGraphic(renderer.getDisplayImage(item));
				}
			}
		}
	}

}