import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.layout.AnchorPane;

import org.controlsfx.control.spreadsheet.GridBase;
import org.controlsfx.control.spreadsheet.SpreadsheetCell;
import org.controlsfx.control.spreadsheet.SpreadsheetCellType;
import org.controlsfx.control.spreadsheet.SpreadsheetView;

public class DesktopView extends AnchorPane {

	private DesktopControler controler;
	private ArrayList<ObservableList<SpreadsheetCell>> theRows;
	private GridBase myGrid;
	private SpreadsheetView mySpread;

	@FXML
	private AnchorPane main;

	public DesktopView(DesktopControler _controler) {

		this.controler = _controler;

		FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("desktop.fxml"));
		fxmlLoader.setRoot(this);
		fxmlLoader.setController(this);

		try {
			fxmlLoader.load();
		} catch (IOException exception) {
			throw new RuntimeException(exception);
		}

		Button butt = new Button("change Grid !!!");
		butt.setOnAction(new EventHandler<ActionEvent>() {
			@Override
			public void handle(ActionEvent arg0) {
				changeGrid();
			}
		});
		this.main.getChildren().add(butt);

		this.myGrid = new GridBase(1, 12);
		this.theRows = new ArrayList<>();

		List<String> enteteCols = new ArrayList<>();
		enteteCols.add("Colonne 1");
		enteteCols.add("Colonne 2");
		enteteCols.add("Colonne 3");
		enteteCols.add("Colonne 1");
		enteteCols.add("Colonne 2");
		enteteCols.add("Colonne 3");
		enteteCols.add("Colonne 1");
		enteteCols.add("Colonne 2");
		enteteCols.add("Colonne 3");
		enteteCols.add("Colonne 1");
		enteteCols.add("Colonne 2");
		enteteCols.add("Colonne 3");
		myGrid.setColumnHeaders(enteteCols);

		ObservableList<SpreadsheetCell> myFirstRow = FXCollections.observableArrayList();
		SpreadsheetCell cell4 = SpreadsheetCellType.STRING.createCell(0, 0, 1, 1, "1_1");
		cell4.setGraphic(new CheckBox());
		SpreadsheetCell cell5 = SpreadsheetCellType.STRING.createCell(0, 1, 1, 1, "1_2");
		cell5.setGraphic(new CheckBox());
		SpreadsheetCell cell6 = SpreadsheetCellType.STRING.createCell(0, 2, 1, 1, "1_3");
		cell6.setGraphic(new CheckBox());
		SpreadsheetCell cell7 = SpreadsheetCellType.STRING.createCell(0, 3, 1, 1, "1_1");
		cell7.setGraphic(new CheckBox());
		SpreadsheetCell cell8 = SpreadsheetCellType.STRING.createCell(0, 4, 1, 1, "1_2");
		cell8.setGraphic(new CheckBox());
		SpreadsheetCell cell9 = SpreadsheetCellType.STRING.createCell(0, 5, 1, 1, "1_3");
		cell9.setGraphic(new CheckBox());
		SpreadsheetCell cell10 = SpreadsheetCellType.STRING.createCell(0, 6, 1, 1, "1_1");
		cell10.setGraphic(new CheckBox());
		SpreadsheetCell cell11 = SpreadsheetCellType.STRING.createCell(0, 7, 1, 1, "1_2");
		cell11.setGraphic(new CheckBox());
		SpreadsheetCell cell12 = SpreadsheetCellType.STRING.createCell(0, 8, 1, 1, "1_3");
		cell12.setGraphic(new CheckBox());
		SpreadsheetCell cell13 = SpreadsheetCellType.STRING.createCell(0, 9, 1, 1, "1_1dflgkdflkj fdlkgjdflhjflj ljdflgjofjofghj\nlkfjgdfjodriyj");
		cell13.setGraphic(new CheckBox());
		SpreadsheetCell cell14 = SpreadsheetCellType.STRING.createCell(0, 10, 1, 1, null);
		cell14.setGraphic(new CheckBox());
		SpreadsheetCell cell15 = SpreadsheetCellType.STRING.createCell(0, 11, 1, 1, null);
		cell15.setGraphic(new CheckBox());
		myFirstRow.add(cell4);
		myFirstRow.add(cell5);
		myFirstRow.add(cell6);
		myFirstRow.add(cell7);
		myFirstRow.add(cell8);
		myFirstRow.add(cell9);
		myFirstRow.add(cell10);
		myFirstRow.add(cell11);
		myFirstRow.add(cell12);
		myFirstRow.add(cell13);
		myFirstRow.add(cell14);
		myFirstRow.add(cell15);
		theRows.add(myFirstRow);
		myGrid.setRows(theRows);

		this.mySpread = new SpreadsheetView(myGrid);
		AnchorPane.setBottomAnchor(mySpread, 0d);
		AnchorPane.setTopAnchor(mySpread, 30d);
		AnchorPane.setRightAnchor(mySpread, 0d);
		AnchorPane.setLeftAnchor(mySpread, 0d);
		this.main.getChildren().add(mySpread);

		for (int i = 0; i < 100; i++) {
			ObservableList<SpreadsheetCell> aRow = FXCollections.observableArrayList();
			cell4 = SpreadsheetCellType.STRING.createCell(i, 0, 1, 1, "1_1");
			cell4.setGraphic(new CheckBox());
			cell5 = SpreadsheetCellType.STRING.createCell(i, 1, 1, 1, "1_2");
			cell5.setGraphic(new CheckBox());
			cell6 = SpreadsheetCellType.STRING.createCell(i, 2, 1, 1, "1_3");
			cell6.setGraphic(new CheckBox());
			cell7 = SpreadsheetCellType.STRING.createCell(i, 3, 1, 1, "1_1");
			cell7.setGraphic(new CheckBox());
			cell8 = SpreadsheetCellType.STRING.createCell(i, 4, 1, 1, "1_2");
			cell8.setGraphic(new CheckBox());
			cell9 = SpreadsheetCellType.STRING.createCell(i, 5, 1, 1, "1_3");
			cell9.setGraphic(new CheckBox());
			cell10 = SpreadsheetCellType.STRING.createCell(i, 6, 1, 1, "1_1");
			cell10.setGraphic(new CheckBox());
			cell11 = SpreadsheetCellType.STRING.createCell(i, 7, 1, 1, "1_2");
			cell11.setGraphic(new CheckBox());
			cell12 = SpreadsheetCellType.STRING.createCell(i, 8, 1, 1, "1_3");
			cell12.setGraphic(new CheckBox());
			cell13 = SpreadsheetCellType.STRING.createCell(i, 9, 1, 1, "1_1dflgkdflkj fdlkgjdflhjflj ljdflgjofjofghj\nlkfjgdfjodriyj");
			cell13.setGraphic(new CheckBox());
			cell14 = SpreadsheetCellType.STRING.createCell(i, 10, 1, 1, null);
			cell14.setGraphic(new CheckBox());
			cell15 = SpreadsheetCellType.STRING.createCell(i, 11, 1, 1, null);
			cell15.setGraphic(new CheckBox());
			aRow.add(cell4);
			aRow.add(cell5);
			aRow.add(cell6);
			aRow.add(cell7);
			aRow.add(cell8);
			aRow.add(cell9);
			aRow.add(cell10);
			aRow.add(cell11);
			aRow.add(cell12);
			aRow.add(cell13);
			aRow.add(cell14);
			aRow.add(cell15);
			theRows.add(aRow);
		}
		myGrid.setRows(theRows);
		mySpread.setGrid(myGrid);
	}

	private void changeGrid() {

		this.theRows.clear();
		for (int i = 0; i < 100; i++) {
			ObservableList<SpreadsheetCell> aRow = FXCollections.observableArrayList();
			SpreadsheetCell cell4 = SpreadsheetCellType.STRING.createCell(i, 0, 1, 1, "2_1");
			cell4.setGraphic(new CheckBox());
			SpreadsheetCell cell5 = SpreadsheetCellType.STRING.createCell(i, 1, 1, 1, "2_2");
			cell5.setGraphic(new CheckBox());
			SpreadsheetCell cell6 = SpreadsheetCellType.STRING.createCell(i, 2, 1, 1, "2_3");
			cell6.setGraphic(new CheckBox());
			SpreadsheetCell cell7 = SpreadsheetCellType.STRING.createCell(i, 3, 1, 1, "2_1");
			cell7.setGraphic(new CheckBox());
			SpreadsheetCell cell8 = SpreadsheetCellType.STRING.createCell(i, 4, 1, 1, "2_2");
			cell8.setGraphic(new CheckBox());
			SpreadsheetCell cell9 = SpreadsheetCellType.STRING.createCell(i, 5, 1, 1, "2_3");
			cell9.setGraphic(new CheckBox());
			SpreadsheetCell cell10 = SpreadsheetCellType.STRING.createCell(i, 6, 1, 1, "2_1");
			cell10.setGraphic(new CheckBox());
			SpreadsheetCell cell11 = SpreadsheetCellType.STRING.createCell(i, 7, 1, 1, "2_2");
			cell11.setGraphic(new CheckBox());
			SpreadsheetCell cell12 = SpreadsheetCellType.STRING.createCell(i, 8, 1, 1, "2_3");
			cell12.setGraphic(new CheckBox());
			SpreadsheetCell cell13 = SpreadsheetCellType.STRING
					.createCell(i, 9, 1, 1, "1_1dflgkdflkj fdlkgjdflhjflj ljdflgjofjofghj\nlkfjgdfjodriyj");
			cell13.setGraphic(new CheckBox());
			SpreadsheetCell cell14 = SpreadsheetCellType.STRING.createCell(i, 10, 1, 1, null);
			cell14.setGraphic(new CheckBox());
			SpreadsheetCell cell15 = SpreadsheetCellType.STRING.createCell(i, 11, 1, 1, null);
			cell15.setGraphic(new CheckBox());
			aRow.add(cell4);
			aRow.add(cell5);
			aRow.add(cell6);
			aRow.add(cell7);
			aRow.add(cell8);
			aRow.add(cell9);
			aRow.add(cell10);
			aRow.add(cell11);
			aRow.add(cell12);
			aRow.add(cell13);
			aRow.add(cell14);
			aRow.add(cell15);
			theRows.add(aRow);
		}
		myGrid.setRows(theRows);
		mySpread.setGrid(myGrid);
	}
}
