package com.six_group.sse.seni.guicontrols.checkboxcombo;

import javafx.scene.image.ImageView;

/**
 * Cell renderer for the {@link CheckBoxComboBox}. If none is specified the
 * combo will use toString().
 * 
 * @author tkcr1
 *
 * @param <T>
 *            {@link CheckBoxComboBox#T}
 */
public interface ICheckBoxComboBoxCellRenderer<T> {

	/**
	 * Should return the display text to show for the given object.
	 * 
	 * @param object
	 *            Object to show display text for
	 * @return String to display or null if nothing
	 */
	String getDisplayText(T object);

	/**
	 * Should return the display image to show for the given object.
	 * 
	 * @param object
	 *            Object to show display image for
	 * @return Image or null for no image
	 */
	ImageView getDisplayImage(T object);
}
