package com.six_group.sse.seni.guicontrols.checkboxcombo;

import java.util.List;

/**
 * Title renderer for {@link CheckBoxComboBox}. This is used to display the text
 * in the cell that is used for the closed combo (that is usually used for
 * showing the selected item).
 * 
 * @author tkcr1
 *
 * @param <T>
 *            {@link CheckBoxComboBox#T}
 */
public interface ICheckBoxComboBoxTitleRenderer<T> {

	/**
	 * Should return the title string to show.
	 * 
	 * @param selectedItems
	 *            Items currently selected (may be null)
	 * @param allSelected
	 *            true if all items are currently selected
	 * @return String to display or null to show no string
	 */
	String getTitleString(List<T> selectedItems, boolean allSelected);
}
