package bugs.controlsfx.popover;

import org.controlsfx.control.PopOver;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

public class PopOverBug extends Application {
	
	private BorderPane root;
	
	@Override
	public void start(final Stage stage) throws Exception {
        stage.setTitle(PopOverBug.class.getSimpleName());
        
        root = new BorderPane();
        Scene scene = new Scene(root, 800, 600);
 
        Button popOverButton = new Button("Settings via PopOver");
        popOverButton.setOnAction(this::handlePopOverSettingsAction);
        
        Button alertButton = new Button("Settings via Alert");
        alertButton.setOnAction(this::handleAlertSettingsAction);
        
        HBox box = new HBox();
        box.getChildren().addAll(popOverButton, alertButton);
        
        root.setTop(box);

        stage.setScene(scene);
        stage.show();
	}

	private void handlePopOverSettingsAction(ActionEvent e) {
		Node settingsView = new SettingsView();       
		PopOver dialog = PopOverFactory.createPopOver(settingsView, "Settings");
		dialog.show(root, 200, 200);
		dialog.setDetached(true);
	}
	
	private void handleAlertSettingsAction(ActionEvent e) {
		Node settingsView = new SettingsView();       
		Alert dialog = PopOverFactory.createConfirmationDialog(settingsView, "Settings");
		dialog.show();
	}
	
	public static void main(String[] args) {
		launch(args);
	}
	
}
