package bugs.controlsfx.popover;

import org.controlsfx.control.PopOver;

import javafx.scene.Node;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;

public class PopOverFactory {

	private PopOverFactory() {
		// Only static utility methods.
	}
	
	public static PopOver createPopOver(Node content, String title) {
        PopOver popOver = new PopOver(content);
        popOver.setTitle(title);
        popOver.setHeaderAlwaysVisible(true);
        popOver.setDetachable(true);
        return popOver;
    }

	public static Alert createConfirmationDialog(Node content, String title) {
		Alert alert = new Alert(AlertType.CONFIRMATION);
		alert.setTitle(title);
		alert.getDialogPane().setContent(content);
        return alert;
    }
	
}
