package bugs.controlsfx.popover;

import java.time.LocalDate;
import java.time.Month;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Optional;

import org.controlsfx.control.PropertySheet;
import org.controlsfx.control.PropertySheet.Item;

import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.layout.BorderPane;

public class SettingsView extends BorderPane {

	private static Map<String, Object> customDataMap = new LinkedHashMap<>();

	static {
		customDataMap.put("1. Name#First Name", "Jonathan");
		customDataMap.put("1. Name#Last Name", "Giles");
		customDataMap.put("1. Name#Birthday", LocalDate.of(1985, Month.JANUARY, 12));
		customDataMap.put("2. Billing Address#Address 1", "");
		customDataMap.put("2. Billing Address#Address 2", "");
		customDataMap.put("2. Billing Address#City", "");
		customDataMap.put("2. Billing Address#State", "");
		customDataMap.put("2. Billing Address#Zip", "");
		customDataMap.put("3. Phone#Home", "123-123-1234");
		customDataMap.put("3. Phone#Mobile", "234-234-2345");
		customDataMap.put("3. Phone#Work", "");
	}

	class CustomPropertyItem implements Item {

		private String key;
		private String category, name;

		public CustomPropertyItem(String key) {
			this.key = key;
			String[] skey = key.split("#");
			category = skey[0];
			name = skey[1];
		}

		@Override
		public Class<?> getType() {
			return customDataMap.get(key).getClass();
		}

		@Override
		public String getCategory() {
			return category;
		}

		@Override
		public String getName() {
			return name;
		}

		@Override
		public String getDescription() {
			return null;
		}

		@Override
		public Object getValue() {
			return customDataMap.get(key);
		}

		@Override
		public void setValue(Object value) {
			customDataMap.put(key, value);
			System.out.println(key + ": " + value);
		}

		@Override
		public Optional<ObservableValue<? extends Object>> getObservableValue() {
			return Optional.empty();
		}

//		@Override
//		public boolean isEditable() {
//			return true;
//		}
	}
	
    private ObservableList<Item> getCustomModelProperties() {
        ObservableList<Item> list = FXCollections.observableArrayList();
        for (String key : customDataMap.keySet()) {
            list.add(new CustomPropertyItem(key));
        }
        return list;
    }

	private final ObservableList<Item> customModelProperties;

	private final PropertySheet propertySheet;
	
	public SettingsView() {
		setPrefSize(400, 400);
		
		customModelProperties = getCustomModelProperties();
		
		propertySheet = new PropertySheet(customModelProperties);
		
		setCenter(propertySheet);
		
		
	}

}
