// package dk.ti.share5.client.cache;
//
// import static dk.ti.common.dbbase.ModelHelper.transfer;
//
// import java.io.IOException;
// import java.util.HashMap;
// import java.util.List;
// import java.util.Map;
// import java.util.Map.Entry;
// import java.util.function.Function;
//
// import dk.ti.common.dbbase.ModelHelper.HandleIncomplientSetter;
// import dk.ti.common.dbbase.SpringApplicationContext;
// import dk.ti.share5.client.cache.user.CurrentUserCache;
// import dk.ti.share5.client.model.sharefile.ShareClientFileDB;
// import dk.ti.share5.client.model.sharefile.ShareClientProjectDB;
// import dk.ti.share5.client.model.sharefile.dao.ShareClientFileDAO;
// import dk.ti.share5.client.model.sharefile.dao.ShareClientProjectDAO;
// import dk.ti.share5.model.sharefile.ShareFile;
// import dk.ti.share5.model.sharefile.ShareProject;
// import dk.ti.share5.model.sharefile.rest.ShareFileRestInvoker;
// import dk.ti.share5.model.sharefile.rest.ShareProjectRestInvoker;
//
// public class LocalFilesUpdater {
//
// public static ShareClientProjectDB downloadProject(ShareProject serverProject) throws IOException {
// ShareClientProjectDB localProject = new ShareClientProjectDB();
// transfer(localProject, serverProject, null);
// localProject = projectDAO().save(localProject, getUser());
//
// updateProject(localProject, serverProject);
//
// return localProject;
// }
//
// public static void invokeUpdate() throws IOException {
// updateProjects();
// }
//
// private static void createNewLocalFile(ShareFile serverFile) {
// ShareClientFileDB localFile = new ShareClientFileDB();
// transfer(localFile, serverFile, new HandleIncomplientSetter<ShareClientFileDB, ShareFile>() {
//
// @Override
// public boolean handleSetter(ShareClientFileDB target, ShareFile source, String methodId) {
// switch (methodId) {
// case "project":
// target.setProject(projectDAO().byProjectNo(source.getProject().getProjectno()));
// return true;
// default:
// return false;
// }
// }
// });
// fileDAO().save(localFile, getUser());
// }
//
// private static ShareClientFileDAO fileDAO() {
// return SpringApplicationContext.getBean(ShareClientFileDAO.class);
// }
//
// private static String getPwd() {
// return userCache().getUser().getPwd();
// }
//
// private static String getUser() {
// return userCache().getUser().getUser();
// }
//
// private static ShareClientProjectDAO projectDAO() {
// return SpringApplicationContext.getBean(ShareClientProjectDAO.class);
// }
//
// private static ShareFileRestInvoker restFile() {
// return SpringApplicationContext.getBean(ShareFileRestInvoker.class);
// }
//
// private static ShareProjectRestInvoker restProject() {
// return SpringApplicationContext.getBean(ShareProjectRestInvoker.class);
// }
//
// private static <T> Map<Long, T> toMap(List<T> items, Function<T, Long> getId) {
// Map<Long, T> result = new HashMap<>(items.size());
// for (T item : items) {
// result.put(getId.apply(item), item);
// }
// return result;
// }
//
// private static void updateLocalFile(ShareClientFileDB localFile, ShareFile serverFile) {
// if(localFile.getLastmodified() < serverFile.getLastmodified()) {
// transfer(localFile, serverFile, null);
// fileDAO().save(localFile, getUser());
// }
// }
//
// private static void updateProject(ShareClientProjectDB localProject, ShareProject serverProject) throws IOException {
// if(localProject.getLastmodified() < serverProject.getLastmodified()) {
// transfer(localProject, serverProject, null);
// projectDAO().save(localProject, getUser());
// }
//
// Map<Long, ShareFile> serverFiles = toMap(restFile().list(getUser(), getPwd(), serverProject), (sp) -> sp.getId());
// Map<Long, ShareClientFileDB> localFiles = toMap(fileDAO().byProject(localProject), (lp) -> lp.getRemoteId());
//
// for (Entry<Long, ShareFile> serverFile : serverFiles.entrySet()) {
// ShareClientFileDB localFile = localFiles.remove(serverFile.getKey());
// if(localFile == null) {
// // Local file not found!
// createNewLocalFile(serverFile.getValue());
// } else {
// updateLocalFile(localFile, serverFile.getValue());
// }
// }
// }
//
// private static void updateProjects() throws IOException {
// List<ShareClientProjectDB> localProjects = projectDAO().getAll();
//
// for (ShareClientProjectDB localProject : localProjects) {
// ShareProject serverProject = restProject().get(getUser(), getPwd(), localProject.getId());
// updateProject(localProject, serverProject);
// }
// }
//
// private static CurrentUserCache userCache() {
// return SpringApplicationContext.getBean(CurrentUserCache.class);
// }
// }