package dk.ti.share5.client.gui;

import javafx.collections.ObservableList;
import javafx.util.StringConverter;

public abstract class AbstractShareConverter<T> extends StringConverter<T> {

	private ObservableList<T> items;

	protected AbstractShareConverter(ObservableList<T> items) {
		this.items = items;
	}

	@Override
	public T fromString(String string) {
		for (T item : items) {
			if(getCaption(item).equals(string)) {
				return item;
			}
		}
		return null;
	}

	@Override
	public String toString(T item) {
		return item == null ? "" : getCaption(item);
	}

	protected abstract String getCaption(T object);
}