package dk.ti.share5.client.gui.fileinfo;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.controlsfx.dialog.Wizard;
import org.controlsfx.dialog.WizardPane;

import javafx.scene.control.ButtonType;

public class FileInfoWizard extends Wizard {

	public FileInfoWizard(List<File> newFiles) throws IOException {
		List<WizardPane> panes = new ArrayList<>();

		for (File newFile : newFiles) {
			panes.add(new FileInfoWizardPane(newFile));
		}
		setFlow(new LinearFlow(panes));
	}

	public void show() {
		// show wizard and wait for response
		showAndWait().ifPresent(result -> {
			if(result == ButtonType.FINISH) {
				System.out.println("Wizard finished, settings: " + getSettings());
			}
		});
	}

	public static class FileInfoWizardPane extends WizardPane {

		public FileInfoWizardPane(File newFile) throws IOException {
			setContent(new FileInfoGUI());
		}
	}
}
