
import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ToggleButton;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;
import org.controlsfx.control.spreadsheet.GridBase;
import org.controlsfx.control.spreadsheet.SpreadsheetCell;
import org.controlsfx.control.spreadsheet.SpreadsheetCellBase;
import org.controlsfx.control.spreadsheet.SpreadsheetCellType;
import org.controlsfx.control.spreadsheet.SpreadsheetView;

/**
 *
 * @author fth
 */
public class SpreadsheetTest extends Application
{
    
    @Override
    public void start(Stage primaryStage)
    {
        Spreadsheet s = new Spreadsheet();
        
        ToggleButton btn = new ToggleButton();
        btn.setText("Toggle");
        btn.setOnAction(new EventHandler<ActionEvent>()
        {
            
            @Override
            public void handle(ActionEvent event)
            {
                if (btn.isSelected())
                {
                    s.hideColumn(s.getColumns().get(2));
                    s.hideColumn(s.getColumns().get(2));
                    s.hideRow(1);
                    s.hideRow(5);
                    s.hideRow(6);
                    s.hideRow(8);
                }
                else
                {
                    s.showColumn(s.getColumns().get(2));
                    s.showColumn(s.getColumns().get(2));
                    s.showRow(1);
                    s.showRow(5);
                    s.showRow(6);
                    s.showRow(8);
                }
            }
        });
        
        BorderPane root = new BorderPane();
        root.setTop(btn);
        root.setCenter(s);
        
        Scene scene = new Scene(root, 800, 480);
        
        primaryStage.setTitle("Hello World!");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        launch(args);
    }
    
}

class Spreadsheet extends SpreadsheetView
{
    public Spreadsheet()
    {
        setGrid(new GridBase(10, 5));
        
        for (int column = 0; column < 5; column++)
        {
            getGrid().getColumnHeaders().add("Column " + column);
            getColumns().get(column).setMinWidth(200);
        }
        
        for (int row = 0; row < 10; row++)
        {
            ObservableList<SpreadsheetCell> cellRow = FXCollections.observableArrayList();
            for (int i = 0; i < 5; i++)
            {
                Cell cell = new Cell(row, i, 1, 1);
                cellRow.add(cell);
            }
            getGrid().getRows().add(cellRow);
        }
    }
}

class Cell extends SpreadsheetCellBase
{
    
    public Cell(int row, int column, int rowSpan, int columnSpan)
    {
        super(row, column, rowSpan, columnSpan, SpreadsheetCellType.STRING);
        
        setStyle("-fx-alignment: CENTER_LEFT;");
        Image image = new Image("file:src/spreadsheettest/Dot.png");
        
        setItem("TEXT TEXT TEXT");
        setGraphic(new ImageView(image));
    }
    
}
