package com.test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.controlsfx.control.spreadsheet.GridBase;
import org.controlsfx.control.spreadsheet.SpreadsheetCell;
import org.controlsfx.control.spreadsheet.SpreadsheetCellType;
import org.controlsfx.control.spreadsheet.SpreadsheetView;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.layout.HBox;
import javafx.stage.Stage;

public class TestMain extends Application {

	List<String> headers = new ArrayList<>(Arrays.asList("ThisIsAReallyLongHeaderNameThatCanBeAnIssueToView", "ShortName"));

	public static void main(String[] args) {
		launch(args);
	}
	
	public void start(Stage primaryStage) {
		Thread.setDefaultUncaughtExceptionHandler(
				new Thread.UncaughtExceptionHandler() {
					@Override public void uncaughtException(Thread t, Throwable e) {
						System.out.println(e);
					}
				});
			HBox viewBox = new HBox();

			ObservableList<ObservableList<SpreadsheetCell>> tableRows = createFakeData();

			GridBase mainGridBase = new GridBase(headers.size(), tableRows.size());
			
			mainGridBase.setRows(tableRows);
			mainGridBase.getRowHeaders().clear();
			mainGridBase.getRowHeaders().addAll(headers);

			SpreadsheetView spreadsheet = new SpreadsheetView(mainGridBase);
			spreadsheet.setRowHeaderWidth(400);
			
			viewBox.getChildren().add(spreadsheet);

			Scene scene = new Scene(viewBox);
			primaryStage.setScene(scene);
			primaryStage.show();
	}

	private ObservableList<ObservableList<SpreadsheetCell>> createFakeData() {
		List<ObservableList<SpreadsheetCell>> cells = new ArrayList<>();
		for(int i = 1; i <= headers.size(); i++){
			List<SpreadsheetCell> row = new ArrayList<>();
			for(int j = 0; j < 10; j++){
				SpreadsheetCell cell = SpreadsheetCellType.STRING.createCell(i, j, 1, 1, "Data at "+i+", "+j);
				row.add(cell);
			}
			cells.add(FXCollections.observableArrayList(row));
		}
		return FXCollections.observableArrayList(cells);
	}
}
