package com.something;

import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import org.controlsfx.control.PopOver;

/**
 * Created by ubuntu on 12/27/16.
 */
public class Main extends Application {
    public static void main(String[] args) {
        launch(args);
    }

    public void start(Stage primaryStage) throws Exception {
        final TextField field1 = new TextField("Some value");
        final TextField field2 = new TextField("Some value");

        addPopOver(field1);
        addPopOver(field2);

        VBox layout = new VBox();
        layout.setSpacing(10);
        layout.setPadding(new Insets(10));
        layout.getChildren().add(field1);
        layout.getChildren().add(field2);

        Scene scene = new Scene(layout);

        primaryStage.setMinHeight(150);
        primaryStage.setMinWidth(150);
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    private void addPopOver(TextField field) {
        final PopOver popOver = new PopOver();
        popOver.setDetachable(false);
        popOver.setAnimated(true);
        popOver.setAutoHide(false);
        popOver.setContentNode(new Label("Label content"));

        field.focusedProperty().addListener((observable, oldValue, newValue) -> {
            if (!newValue) {
                popOver.show(field);
            }
        });
    }
}
