/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package bugtest;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.GridPane;
import javafx.stage.Stage;
import org.controlsfx.control.PropertySheet;
import org.controlsfx.property.BeanPropertyUtils;

/**
 *
 * @author Geoff
 */
public class PropertySheetTraversal extends Application {
	
	@Override
	public void start(Stage primaryStage) {
		
		BorderPane mainPane = new BorderPane();
		
		GridPane gp = new GridPane();
		gp.setPadding(new Insets(4));
		gp.setHgap(4);
		gp.setVgap(4);
		
		TextField tfF1 = new TextField();
		
		gp.addRow(0, new Label("Field 1:"), tfF1);
		
		TextField tfF2 = new TextField();
		
		gp.addRow(1, new Label("Field 2:"), tfF2);
		
		mainPane.setTop(gp);
		
		
		TestObject tObj = new TestObject("Monty", "Burns");
		
		PropertySheet ps = new PropertySheet(BeanPropertyUtils.getProperties(tObj));
		
		mainPane.setCenter(ps);
		
		
		FlowPane fp = new FlowPane(4,4);
		fp.setPadding(new Insets(4));
		fp.setAlignment(Pos.CENTER_RIGHT);
		
		fp.getChildren().addAll(new Button("Save"), new Button("Cancel"));
		
		mainPane.setBottom(fp);
		
		Scene scene = new Scene(mainPane, 400, 250);
		
		primaryStage.setTitle("Focus Test");
		primaryStage.setScene(scene);
		primaryStage.show();
		
		Platform.runLater(() -> {
			tfF1.requestFocus();
		});
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) {
		launch(args);
	}
	
	
	public class TestObject {
		
		private String firstName;
		
		private String lastName;
		
		public TestObject(String firstName, String lastName) {
			this.firstName = firstName;
			this.lastName = lastName;
		}

		/**
		 * @return the firstName
		 */
		public String getFirstName() {
			return firstName;
		}

		/**
		 * @param firstName the firstName to set
		 */
		public void setFirstName(String firstName) {
			this.firstName = firstName;
		}

		/**
		 * @return the lastName
		 */
		public String getLastName() {
			return lastName;
		}

		/**
		 * @param lastName the lastName to set
		 */
		public void setLastName(String lastName) {
			this.lastName = lastName;
		}
		
	}
	
	
}
