package mint;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.control.TextField;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

import org.controlsfx.control.textfield.AutoCompletionBinding;
import org.controlsfx.control.textfield.TextFields;

public class AutoCompleteTest extends Application
{
  public static void main(String[] args)
  {
    Application.launch(args);
  }
  
  @Override
  public void start(Stage primaryStage) throws Exception
  {
    TextField textField = TextFields.createSearchField();
    AutoCompletionBinding<String> autoCompletionBinding = TextFields.bindAutoCompletion(textField, "lorem", "ipsum");
    
    // never fired:
    autoCompletionBinding.setOnAutoCompleted(e -> System.out.println("completion: " + e.getCompletion()));
    
    primaryStage.setScene(new Scene(new StackPane(textField), 800, 600));
    primaryStage.show();
  }

}
