package tests.rangeslider;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.scene.Scene;
import javafx.scene.control.ContextMenu;
import javafx.scene.control.CustomMenuItem;
import javafx.scene.control.Label;
import javafx.scene.control.MenuItem;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

import org.controlsfx.control.RangeSlider;

/**
 * Test of RangeSlider in a Context menu.
 * 
 * @author Gilberto Gomez G
 */
public class SliderTest extends Application {
  
  @Override
  public void start(Stage primaryStage) throws Exception {
    RangeSlider rangeSlider = new RangeSlider(0, 24, 8, 18);
    
    ContextMenu contextMenu = new ContextMenu(new MenuItem("Normal menu item"), new CustomMenuItem(rangeSlider, false));
    
    Label label = new Label("Right-mouse click me!");
    label.setContextMenu(contextMenu);
    
    StackPane pane = new StackPane(label);
    
    primaryStage.setScene(new Scene(pane, 400, 300));
    primaryStage.setTitle("Slider on ContextMenu test");
    primaryStage.setOnHidden(evt -> Platform.exit());
    primaryStage.show();
  }
  
  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) {
    launch(args);
  }
}
