package test;

import org.controlsfx.control.PopOver;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ToolBar;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;

/**
 * PopOverTest.
 * 
 * @author Gilberto Gomez G
 */
public class PopOverTest extends Application {
  
  @Override
  public void start(Stage primaryStage) throws Exception {
    ToolBar toolbar = new ToolBar();
    
    // fill with dummy buttons so the last ones are shown in a menu
    for (int i = 0; i < 12; i++) {
      Button button = new Button("dummy");
      toolbar.getItems().add(button);
    }
    
    PopOver popOver = new PopOver(new Label("Pop Over Content"));
    
    Button button = new Button("popover");
    button.setOnAction(evt -> {
      popOver.show(button);
    });
    toolbar.getItems().add(button);
    
    BorderPane pane = new BorderPane();
    pane.setTop(toolbar);
    
    primaryStage.setScene(new Scene(pane, 500, 250));
    primaryStage.show();
  }
  
  public static void main(String[] args) {
    launch(args);
  }
  
}
