package com.ait.jetabledesign;

import javafx.application.Application;
import static javafx.application.Application.launch;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.SelectionMode;
import javafx.scene.input.Clipboard;
import javafx.scene.input.DataFormat;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyCodeCombination;
import javafx.scene.input.KeyCombination;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;
import org.controlsfx.control.spreadsheet.GridBase;
import org.controlsfx.control.spreadsheet.SpreadsheetCell;
import org.controlsfx.control.spreadsheet.SpreadsheetCellType;
import org.controlsfx.control.spreadsheet.SpreadsheetColumn;
import org.controlsfx.control.spreadsheet.SpreadsheetView;

public class MainApp extends Application implements EventHandler<KeyEvent> {

    private final ObservableList<ObservableList<SpreadsheetCell>> rows = FXCollections.observableArrayList();
    private ObservableList<SpreadsheetCell> cells;
    private ObservableList<String> listAttribute = FXCollections.observableArrayList();
    private SpreadsheetView spv;
    private GridBase grid;
    private DataFormat fmt;
    @Override
    public void start(Stage stage) throws Exception {
        for (int i = 0; i < 10; i++) {
            listAttribute.add("");
        }
        
        
        int rowCount = 1000;
        int columnCount = listAttribute.size();
        grid = new GridBase(rowCount, columnCount);

        for (int row = 0; row < grid.getRowCount(); ++row) {
            cells = FXCollections.observableArrayList();
            for (int column = 0; column < grid.getColumnCount(); ++column) {
                if (column == 1) {
                    SpreadsheetCell cellIndex = SpreadsheetCellType.STRING.createCell(row, column, 1, 1, null);
                    cellIndex.setGraphic(new ComboBox());
                    cellIndex.setEditable(false);

                    cells.add(cellIndex);

                } else {
                    cells.add(SpreadsheetCellType.STRING.createCell(row, column, 1, 1, ""));
                }
            }

            rows.add(cells);
        }
        grid.setRows(rows);

        spv = new SpreadsheetView(grid);

        ObservableList<SpreadsheetColumn> colList = spv.getColumns();

        for (SpreadsheetColumn colListElement : colList) {
            colListElement.setPrefWidth(150);
        }
        spv.setEditable(true);
        spv.getSelectionModel().setCellSelectionEnabled(true);
        spv.getSelectionModel().setSelectionMode(SelectionMode.MULTIPLE);
        spv.addEventHandler(KeyEvent.ANY, this);

        BorderPane root = new BorderPane();
        root.setTop(new Button("Create Structure"));
        root.setCenter(spv);

        Scene scene = new Scene(root);
      
        scene.getAccelerators().put(new KeyCodeCombination(KeyCode.C, KeyCombination.CONTROL_ANY), new Runnable() {
            @Override
            public void run() {
                System.out.println("COPY");
//                ClipboardContent content = new ClipboardContent();              
//                Clipboard clipboard = Clipboard.getSystemClipboard();
//                System.out.println("content----->"+content);
//                clipboard.setContent(content);

                spv.copyClipboard();
            }
        });
        scene.getAccelerators().put(new KeyCodeCombination(KeyCode.V, KeyCombination.CONTROL_ANY), new Runnable() {
            @Override
            public void run() {
                System.out.println("PASTE");
                Clipboard clipboard = Clipboard.getSystemClipboard();
                System.out.println(clipboard.getString());

                spv.pasteClipboard();
            }
        });

        stage.setTitle("JavaFX and Maven");
        stage.setScene(scene);
        stage.show();
    }

    /**
     * The main() method is ignored in correctly deployed JavaFX application.
     * main() serves only as fallback in case the application can not be
     * launched through deployment artifacts, e.g., in IDEs with limited FX
     * support. NetBeans ignores main().
     *
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void handle(KeyEvent event) {
        if (event.getCode().equals(KeyCode.ENTER)) {
            System.out.println("KEY ON FUNCTION!!!!!!");
        } else if (event.isShortcutDown() && event.getCode().compareTo(KeyCode.V) == 0) {
            System.out.println();
        }
    }
}
