
import javafx.collections.ObservableList;
import org.controlsfx.control.PropertySheet;
import org.controlsfx.property.BeanPropertyUtils;

public class BPUTest {

    /**
     * This only lists property 'name' and not the read-only property 'sex'
     */
    public static void main(String[] args) {
        TestBean testBean = new TestBean("Michael", "male");
        ObservableList<PropertySheet.Item> ps = BeanPropertyUtils.getProperties(testBean);
        System.out.println("== Properties ===");
        ps.forEach((p) -> System.out.println(p.getName()));
        System.out.println("=================");
    }
}

/**
 * Simple bean with one read.write property (name) and one read-only property (sex)
 * 
 */
class TestBean {

    String name;
    String sex;

    public TestBean(String name, String sex) {
        this.name = name;
        this.sex = sex;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSex() {
        return sex;
    }
}
