package propertysheetdemo;

import java.util.ArrayList;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import org.controlsfx.control.PropertySheet;
import org.controlsfx.property.BeanPropertyUtils;

public class PropertySheetDemo extends Application {

    @Override
    public void start(Stage primaryStage) {
        ArrayList<String> names = new ArrayList<>();
        names.add("Mickey Mouse");
        names.add("Donald Duck");
        names.add("Pluto");
        names.add("Goofy");

        final Person person = new Person(names.get(0));

        PropertySheet propertySheet = new PropertySheet(BeanPropertyUtils.getProperties(person));

        Button btnChangeName = new Button("Change Name");
        btnChangeName.setOnAction((e) -> {
            person.setName(names.get((names.indexOf(person.getName()) + 1) % names.size()));
        }
        );

        Button btnRefresh = new Button("Refresh");
        btnRefresh.setOnAction((e) -> {
            // Cludge to force PropertySheet to refresh properties.
            propertySheet.setTitleFilter("a");
            propertySheet.setTitleFilter("");
        }
        );

        VBox root = new VBox();
        root.getChildren().addAll(btnChangeName, btnRefresh, propertySheet);

        Scene scene = new Scene(root, 300, 250);

        primaryStage.setTitle("Property Sheet Bug!");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }

}
