import org.controlsfx.control.PopOver;

import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.scene.text.Text;
import javafx.stage.Stage;

public class RefreshTest extends Application {
	
	@Override
	public void start(Stage primaryStage) {
		try {

			launchPrimaryStage( primaryStage );
			
			Stage refreshStage = new Stage();
			
			Text text = new Text("1. Refresh primary stage without opening popover." );
			Text text2 = new Text("2. Refresh primary stage after opening popover." );
			Button refreshButton = new Button("Refresh Primary Stage");
			
			VBox pane = new VBox(text, text2, refreshButton );
			pane.setAlignment( Pos.CENTER );
			pane.setSpacing( 5d );
			pane.setPadding( new Insets(10) );
			
			Scene refreshScene = new Scene( pane );
			refreshStage.setScene( refreshScene );
			refreshStage.setTitle("Stage Refresher");
			refreshStage.setMinHeight( 150 );
			refreshStage.setMinWidth( 300 );
			
			refreshButton.setOnAction( evt -> {
				 System.out.println("Refreshing primary stage...");
				 primaryStage.hide();
				 launchPrimaryStage( primaryStage );
			});
			
			refreshStage.setX( 100d );
			
			refreshStage.show();
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	protected void launchPrimaryStage( Stage primaryStage ){
			
		
		Button btn = new Button("Open Popover");
		
		Scene scene = new Scene( new StackPane( btn ) );
		
		btn.setOnAction( evt -> {
			PopOver popover = new PopOver();
			popover.show( btn );
		});
		
		primaryStage.setScene(scene);
		primaryStage.setMinHeight( 150 );
		primaryStage.setMinWidth( 300 );
		primaryStage.setTitle("Primary Stage");
		primaryStage.show();
		
	}
	
	public static void main(String[] args) {
		launch(args);
	}

}
