package controlsfx.testcase;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

import org.controlsfx.control.PropertySheet;
import org.controlsfx.dialog.Dialog;
import org.controlsfx.property.BeanPropertyUtils;


public class NumericFieldPropertySheetIssue extends Application {

	@Override
	public void start(Stage primaryStage) {
		primaryStage.setTitle("Property Sheet Testcase");

		Button btn = new Button();
		btn.setText("Open Sheet");
		btn.setOnAction(new EventHandler<ActionEvent>() {

			@Override
			public void handle(ActionEvent event) {
				MyBean bean = new MyBean();
				
				System.out.println("Before bean is " + bean.toString());
				PropertySheet ps = new PropertySheet(
						BeanPropertyUtils.getProperties(bean));
				Dialog dlg = new Dialog(null, "Property Sheet Test");
				
				dlg.setContent(ps);
				dlg.getActions().addAll(Dialog.Actions.OK);
				dlg.show();
				System.out.println("After bean is " + bean.toString());
				assert(bean.getAge() != MyBean.DEFAULT_AGE);
			}
		});

		StackPane root = new StackPane();
		root.getChildren().add(btn);
		primaryStage.setScene(new Scene(root, 300, 250));
		primaryStage.show();

	}

	public static void main(String[] args) {
		launch(args);
	}
	
	public static class MyBean {
		public static int DEFAULT_AGE=65;
		String name;
		
		int age;

		public MyBean() {
			this.age = DEFAULT_AGE;
		}
		public String getName() {
			return name;
		}

		public void setName(String name) {
			this.name = name;
		}

		public int getAge() {
			return age;
		}

		public void setAge(int age) {
			this.age = age;
		}

		@Override
		public String toString() {
			return "MyBean [name=" + name + ", age=" + age + "]";
		}
		
		
	}
}
