package com.mycompany.controlsfxbugs;

import java.lang.reflect.Field;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Application;
import static javafx.application.Application.launch;
import javafx.application.Platform;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.ComboBox;
import javafx.scene.control.Label;
import javafx.scene.control.Skin;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import org.controlsfx.control.CheckComboBox;


public class MainApp extends Application {

    @Override
    public void start(Stage stage) throws Exception {
        VBox box = new VBox();
        box.setPadding(new Insets(5));
        box.setSpacing(5);
        
        String[] words = {"one", "two", "three"};
        
        ComboBox<String> cb = new ComboBox<>();
        cb.setPrefWidth(250);
        cb.getStyleClass().add("unrounded");
        cb.getItems().addAll(words);
        
        CheckComboBox<String> ccb = new CheckComboBox<>();
        ccb.setPrefWidth(250);
        ccb.getStyleClass().add("unrounded");
        ccb.getItems().addAll(words);
        
        CheckComboBox<String> ccbr = new CheckComboBox<>();
        ccbr.setPrefWidth(250);
        ccbr.getStyleClass().add("unrounded");
        ccbr.getItems().addAll(words);

        Platform.runLater(() -> {
            try {
                Skin<?> skin = ccbr.getSkin();
                Class<? extends Skin> skinCls = skin.getClass();
                Field field = skinCls.getDeclaredField("comboBox");
                field.setAccessible(true);
                ComboBox<?> internal = (ComboBox<?>) field.get(skin);
                internal.getStyleClass().add("unrounded");
            } catch (ReflectiveOperationException ex) {
                ex.printStackTrace();
            }
        });

        box.getChildren().addAll(
                new Label("Expected look:"), cb,
                new Label("Resulting look:"), ccb,
                new Label("With workarround:"), ccbr
        );

        Scene scene = new Scene(box);
        scene.getStylesheets().add("/styles/Styles.css");
        
        stage.setScene(scene);
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }

}
