import javafx.application.Application;
import javafx.stage.Stage;
import org.controlsfx.dialog.Wizard;
import org.controlsfx.dialog.WizardPane;

public class OnExitingPageTest extends Application {
  private static final class TestWizard extends Wizard {
    public TestWizard() {
      setTitle( "page.onExitingPage"  );

      setFlow( new LinearFlow(
          createPage( "first", "Hit Next twice to go to the third page." ),
          createPage( "second", "Look at the output when hitting Previous.\nFirst go to the third page though." ),
          createPage( "third", "Look at the output when hitting Previous." ) ) );
    }

    public WizardPane createPage( String name, String description ) {
      WizardPane pane = new WizardPane() {
        @Override
        public void onEnteringPage( Wizard wizard ) {
          System.out.println( "entering " + name + " page " );
        }

        @Override
        public void onExitingPage( Wizard wizard ) {
          System.out.println( "exiting " + name + " page " );
        }
      };

      pane.setHeaderText( description );
      return pane;
    }
  }

  @Override
  public void start( Stage primaryStage ) throws Exception {
    new TestWizard().showAndWait();
  }

  public static void main( String[] args ) {
    Application.launch( args );
  }
}
