package dsfxcontrols;

import java.io.IOException;
import javafx.application.Application;
import static javafx.application.Application.launch;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import org.controlsfx.control.RangeSlider;

/**
 *
 * @author michaelellis
 */
public class RangeSliderStyleTest extends Application {

    
    RangeSlider createRangeSlider() {
        RangeSlider r = new RangeSlider();
        r.setMin(0);
        r.setMax(100);
        r.setHighValue(75); // Specify low then high value due to RangeSlider bug
        r.setLowValue(25);
        return r;
    }

    @Override
    public void start(Stage primaryStage) throws IOException {

        BorderPane borderPane = new BorderPane();
        borderPane.setPadding(new Insets(10,10,10,10));

        // Verify that we can style a RangeSlider background and border
        RangeSlider r1 = createRangeSlider();
        r1.setStyle("-fx-background-color: ALICEBLUE; -fx-border-color: RED;");
        r1.setShowTickLabels(true);
        r1.setShowTickMarks(true);
        
        // Attempt to style RangeSlider with RangeSlider specific styles for tick lables and marks
        RangeSlider r2 = createRangeSlider();
        r2.setStyle("-fx-background-color: ALICEBLUE; -fx-show-tick-labels: true; -fx-show-tick-marks: true;  -fx-border-color: RED;");

        VBox vbox = new VBox();
        vbox.setSpacing(20);
        vbox.getChildren().addAll(r1, r2);
        borderPane.setCenter(vbox);

        primaryStage.setTitle("RangeSlider Style Test");
        primaryStage.setScene(new Scene(borderPane));
        primaryStage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }

}
