package eu.xxxxx.spt.gui.spreadsheetview.performancetest;

import org.controlsfx.control.spreadsheet.GridBase;
import org.controlsfx.control.spreadsheet.SpreadsheetCell;
import org.controlsfx.control.spreadsheet.SpreadsheetView;

import eu.xxxxx.ting.gui.components.spectable.cells.CellHandler;
import eu.xxxxx.ting.gui.components.spectable.cells.MinMaxDoubleCellHandler;
import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.layout.AnchorPane;
import javafx.scene.paint.Color;
import javafx.stage.Stage;

/**
 * Some tests for SpreadsheetView.
 */
public class MinMaxDoubleCellHandlerTest extends Application
{
  private SpreadsheetView _spreadsheetView;
  
  /**
   * {@inheritDoc}
   */
  @Override
  public void init()
  {
    
    int rowCount = 10_000;
    int columnCount = 10;
    
    GridBase grid = new GridBase(rowCount, columnCount);
    
    ObservableList<ObservableList<SpreadsheetCell>> rows = FXCollections.observableArrayList();
    for ( int row = 0; row < grid.getRowCount(); ++row )
    {
      final ObservableList<SpreadsheetCell> list = FXCollections.observableArrayList();
      for ( int column = 0; column < grid.getColumnCount(); ++column )
      {
        MinMaxDoubleCellHandler cellHandler = new MinMaxDoubleCellHandler(row, column, 1, 1, Math.random(), Math.random(), null, CellHandler.DEFAULT_FACTORY);
        list.add(cellHandler.getCell());
      }
      rows.add(list);
    }
    grid.setRows(rows);
    
    _spreadsheetView = new SpreadsheetView();
    _spreadsheetView.setGrid(grid);
  }
  
  /**
   * {@inheritDoc}
   */
  @Override
  public void start(Stage stage)
  {
    AnchorPane root = new AnchorPane();
    Scene scene = new Scene(root, Color.ALICEBLUE);
    
    AnchorPane.setLeftAnchor(_spreadsheetView, 0.0);
    AnchorPane.setRightAnchor(_spreadsheetView, 0.0);
    AnchorPane.setTopAnchor(_spreadsheetView, 0.0);
    AnchorPane.setBottomAnchor(_spreadsheetView, 0.0);
    root.getChildren().add(_spreadsheetView);
    
    stage.setTitle("ControlsFX - SpreadsheetView");
    stage.setScene(scene);
    stage.show();
  }
  
  /**
   * {@inheritDoc}
   */
  @Override
  public void stop()
  {
  }
  
  public static void main(String[] parameters)
  {
    launch(parameters);
  }
}