package de.carsten_kunze.SpreadsheetViewTest;

import org.controlsfx.control.spreadsheet.GridBase;
import org.controlsfx.control.spreadsheet.SpreadsheetCell;
import org.controlsfx.control.spreadsheet.SpreadsheetCellType;
import org.controlsfx.control.spreadsheet.SpreadsheetView;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class App extends Application
{
    public static void main(final String[] args)
    {
        launch(args);
    }

    @Override
    public void start(final Stage primaryStage) throws Exception
    {
        final int spanRowCount = 100;
        final int rowCount = 15;
        final int columnCount = 10;
        final GridBase grid = new GridBase(spanRowCount + rowCount, columnCount);
        final ObservableList<ObservableList<SpreadsheetCell>> rows = FXCollections.observableArrayList();
        for (int row = 0; row < spanRowCount; ++row)
        {
            final ObservableList<SpreadsheetCell> list = FXCollections.observableArrayList();
            for (int column = 0; column < grid.getColumnCount(); column += 2)
            {
                final SpreadsheetCell cell = SpreadsheetCellType.STRING.createCell(row, column, 1, 2, "long cell");
                list.add(cell);
                list.add(cell);
            }
            rows.add(list);
        }
        for (int row = 0; row < rowCount; ++row)
        {
            final ObservableList<SpreadsheetCell> list = FXCollections.observableArrayList();
            for (int column = 0; column < grid.getColumnCount(); ++column)
            {
                list.add(SpreadsheetCellType.STRING.createCell(row, column, 1, 1, "extra large value"));
            }
            rows.add(list);
        }
        grid.setRows(rows);

        final SpreadsheetView spv = new SpreadsheetView(grid);

        final StackPane root = new StackPane();
        root.getChildren().add(spv);

        final Scene scene = new Scene(root);

        primaryStage.setScene(scene);
        primaryStage.show();

        for (int col = 0; col < columnCount; ++col)
        {
            spv.getColumns().get(col).fitColumn();
        }
    }
}
