import org.controlsfx.dialog.Dialog;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.GridPane;
import javafx.scene.paint.Color;
import javafx.scene.web.HTMLEditor;
import javafx.stage.Stage;

public class DialogTest extends Application {

	@Override
	public void start(Stage arg0) throws Exception {

		arg0.setTitle("test");

		Scene scene = new Scene((Parent) getPanel(arg0), 800, 400);
		scene.setFill(Color.WHITE);

		arg0.setScene(scene);
		arg0.show();

	}

	public static void main(String[] args) {
		Application.launch(args);
	}

	public Node getPanel(final Stage stage) {

		Button temp = new Button("click here");
		temp.setOnAction(new EventHandler<ActionEvent>() {

			@Override
			public void handle(ActionEvent arg0) {
				final GridPane content = new GridPane();

				Dialog dlg = new Dialog(stage, "Commentaire", true, true);
				HTMLEditor editor = new HTMLEditor();
				editor.setMaxSize(75, 200);
				Button connectButton = new Button("Valider");
				connectButton.setDefaultButton(true);

				// layout a custom GridPane containing the input fields and
				// labels
				content.setHgap(10);
				content.setVgap(10);

				content.add(editor, 0, 0);

				content.add(connectButton, 0, 1);

				// create the dialog with a custom graphic and the gridpane
				// above as the
				// main content region
				dlg.setResizable(false);
//				dlg.setIconifiable(false);
				dlg.setContent(content);
				dlg.show();

			}
		});

		return temp;

	}

}