package bug.controlsfx;

import java.io.IOException;
import java.io.InputStream;

import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.stage.Stage;

public class Main extends Application {

    /**
     * @param args
     *            the starting args
     */
    public static void main(final String[] args) {
        launch(args);
    }

    /** {@inheritDoc} */
    @Override
    public final void start(final Stage stage) {
        final FXMLLoader loader = new FXMLLoader();
        try (InputStream is = getClass().getResourceAsStream("/main.fxml")) {
            loader.load(is);
            final MainController mc = (MainController) loader.getController();
            final Scene scene = new Scene(mc.getView());
            stage.setScene(scene);
            stage.centerOnScreen();
            stage.setTitle("PropertySheetFXML");
            stage.show();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

}
