package org.clemens;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.image.ImageView;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import org.clemens.expandable.ExpandablePane;
import org.clemens.expandable.Position;


public class Demo extends Application
{
	@Override
	public void start(final Stage primaryStage) throws Exception
	{
		final ExpandablePane top = new ExpandablePane();
		top.setPosition(Position.TOP);
		top.setContent(new Label("this is the content\nof the first\npane\nand expands upwards"));
		top.setTitle("A title");

		final ExpandablePane left = new ExpandablePane();
		left.setPosition(Position.LEFT);
		left.setGraphic(new HBox(new Label("Some rotated content"), new Button("And a rotated button")));
		left.setContent(new Label("Some content\non the\nleft\nside"));
		left.setTitle("A very long rotated title");

		final ExpandablePane bottom = new ExpandablePane();
		bottom.setPosition(Position.BOTTOM);
		bottom.setContent(new ImageView("/fireball.jpg"));
		bottom.setTitle("There is a fireball here!");
		bottom.setExpanded(false);

		final ExpandablePane right = new ExpandablePane();
		right.setPosition(Position.RIGHT);
		right.setContent(new VBox(new Button("this\nis\nanother button"), new Button("some text on the button")));
		right.setGraphic(new Label("This is some very long descriptive text that should trigger an ellipsis because it is so long"));

		final ExpandablePane centerA = new ExpandablePane();
		centerA.setPosition(Position.RIGHT);
		centerA.setTitle("a title for this");
		centerA.setContent(new Label("some more\ncontent\nin this node"));

		final ExpandablePane centerB = new ExpandablePane();
		centerB.setPosition(Position.RIGHT);
		centerB.setExpanded(false);
		centerB.setTitle("this is in the middle");
		centerB.setContent(new Label("I'm out of\ntexts that I can put in labels"));

		final ExpandablePane centerC = new ExpandablePane();
		centerC.setPosition(Position.LEFT);
		centerC.setTitle("This will collapse to the right");
		centerC.setContent(new Label("and a final node\nwith another label\nin it"));
		final HBox center = new HBox(centerA, centerB, centerC);

		final BorderPane pane = new BorderPane();
		pane.setTop(bottom);
		pane.setRight(left);
		pane.setBottom(top);
		pane.setLeft(right);
		pane.setCenter(center);

		pane.setPrefHeight(600);

		primaryStage.setScene(new Scene(pane));
		primaryStage.show();
	}
}
