package org.clemens.expandable;

import javafx.beans.property.SimpleObjectProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Objects;

public class NonNullObjectProperty<T> extends SimpleObjectProperty<T>
{
	public NonNullObjectProperty(@Nonnull final T initialValue)
	{
		super(initialValue);
	}

	public NonNullObjectProperty(
			@Nullable final Object bean,
			@Nullable final String name,
			@Nonnull final T initialValue)
	{
		super(bean, name, initialValue);
	}

	@Override
	public final void set(@Nonnull final T newValue)
	{
		super.set(Objects.requireNonNull(newValue));
	}

	@Override
	public final void setValue(@Nonnull final T newValue)
	{
		set(newValue);
	}
}
