package org.clemens.expandable;

import javax.annotation.Nonnull;

public enum Position
{
	TOP
			{
				@Nonnull
				@Override
				public RotatedNode.Amount getRotationAmount()
				{
					return HORIZONTAL_ROTATION;
				}

				@Override
				public void configureExpanderButton(@Nonnull final ExpanderButton button)
				{
					button.setVertical();
					button.useNormalOpening();
				}
			},
	LEFT
			{
				@Nonnull
				@Override
				public RotatedNode.Amount getRotationAmount()
				{
					return VERTICAL_ROTATION;
				}

				@Override
				public void configureExpanderButton(@Nonnull final ExpanderButton button)
				{
					button.setHorizontal();
					button.useInvertedOpening();
				}
			},
	BOTTOM
			{
				@Nonnull
				@Override
				public RotatedNode.Amount getRotationAmount()
				{
					return HORIZONTAL_ROTATION;
				}

				@Override
				public void configureExpanderButton(@Nonnull final ExpanderButton button)
				{
					button.setVertical();
					button.useInvertedOpening();
				}
			},
	RIGHT
			{
				@Nonnull
				@Override
				public RotatedNode.Amount getRotationAmount()
				{
					return VERTICAL_ROTATION;
				}

				@Override
				public void configureExpanderButton(@Nonnull final ExpanderButton button)
				{
					button.setHorizontal();
					button.useNormalOpening();
				}
			};

	private static final RotatedNode.Amount HORIZONTAL_ROTATION = RotatedNode.Amount.NONE;
	private static final RotatedNode.Amount VERTICAL_ROTATION = RotatedNode.Amount.THREE_QUARTER;

	@Nonnull
	public abstract RotatedNode.Amount getRotationAmount();

	public abstract void configureExpanderButton(@Nonnull final ExpanderButton button);
}
