package testutils;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.stage.Stage;
import javafx.util.Callback;

import org.controlsfx.control.GridCell;
import org.controlsfx.control.GridView;

public class TestGrid extends Application {

  static int count;
  private ObservableList<MyItem> myItems = FXCollections.observableArrayList();

  public static void main(String[] args) {
    launch(args);
  }

  @Override
  public void start(Stage stage) throws Exception {
    stage.setScene(createScene());
    stage.setWidth(200);
    stage.setHeight(200);
    stage.centerOnScreen();
    stage.show();
  }

  public Scene createScene() {
    Group root = new Group();
    Scene scene = new Scene(root);
    // Grid
    GridView<MyItem> gridView = new GridView<TestGrid.MyItem>(myItems);
    gridView.prefWidthProperty().bind(scene.widthProperty());
    gridView.prefHeightProperty().bind(scene.heightProperty());
    root.getChildren().add(gridView);
    gridView.setCellFactory(new Callback<GridView<MyItem>, GridCell<MyItem>>() {
      @Override
      public GridCell<MyItem> call(GridView<MyItem> gv) {
        System.out.println("[CALLBACK]MyItem list size " + myItems.size());
        System.out.println("[CALLBACK]Callback to create a new GridCell called " + (++count));
        MyItemCell itemCell = new MyItemCell();
        itemCell.gridViewProperty().set(gridView);
        return itemCell;
      }
    });
    // Add
    Button buttonAdd = new Button("+");
    buttonAdd.setOnAction((ea) -> {
      // Add
        MyItem p = new MyItem("Name " + myItems.size());
        System.out.println("[ADD]MyItem added on call " + count);
        myItems.add(p);
      });
    root.getChildren().add(buttonAdd);
    return scene;
  }

  public static class MyItemCell extends GridCell<MyItem> {

    public MyItemCell() {
      super();
    }

    @Override
    protected void updateItem(MyItem myItem, boolean empty) {
      super.updateItem(myItem, empty);
      if (myItem == null || empty) {
        setGraphic(null);
      } else {
        setText(myItem.name);
      }
    }
  }

  public static class MyItem {
    private String name;

    public MyItem(String name) {
      this.name = name;
    }
  }
}
